CON
  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000
  _irrpin       = 12     'ir receiver module on this pin
  _device       = 0     'accept any device code
        
  _dlyrpt       = 6     'delay before acception code as repeat

VAR
  byte displayRAM[1024]  
  byte vcStack[150]
  byte vcStack2[130] 
  long drQueTable[128]
  byte bCog
  byte dSize
  
OBJ
  CMD_P : "LockPool"
 ' LCD : "LCD_DRIVER"
  term : "PC_INTERFACE" 
  CMD_Q : "LockQueue" 
  IR : "ir_reader_sony"
PUB start |   keycode
  dSize := 16
  term.start(31,30)
  term.locate(1,1)
  
  term.str(@IR_START)
  IR.init(_irrpin,_device,_dlyrpt,true)                 'startup
  term.locate(1,1)
  term.str(@INIT_MM) 
  CMD_P.Initialize(@displayRAM,1024,128,4)
  CMD_Q.Initialize(@drQueTable,128)                      ' creates the queue for storing addresse of pooled strings   
  bCog :=  cognew(LoadBuffer(@COG_RUN,@dSize),@vcStack)
  'GetVincuBuffer
  term.locate(1,24)

  term.out(0)
  term.locate(1,1)
  term.str(@DMTEST)
  repeat
    keycode := IR.fifo_get   'try a get from fifo
    if keycode == -1
      term.locate(1,24)
      term.str(@QNT)
      term.hex(CMD_Q.count,3)
      term.str(string(" "))
      term.str(string(" PTtl:"))
      term.hex(CMD_P.GetMaxFree,4)
      term.locate(1,36)
      term.str(string("Used :"))
      term.hex(CMD_P.GetTotalUsed,4)
      term.str(string(" "))
      term.str(string("Free:"))
      term.hex(CMD_P.FindMaxFree,4)
      if COG_RUN > 1
        term.locate(bCog*4,55)
        term.dec(COG_RUN)
      else
        
        'term.locate(bCog * 4,55)
        'term.out($20)
        'term.dec(CMD_P.FindMaxFree)
        'term.str(string("<"))
        'term.dec(dSize)
        'term.str(string(" "))
        'term.dec(bCog)
        if CMD_P.FindMaxFree < dSize+1 and COG_RUN==0
          
          waitcnt(clkfreq+ cnt)
          bCog := cognew(Clearbuffer(@COG_RUN),@vcStack)
       
        'LCD.pos(4,1)
        'LCD.hex(PopBuffer,8)
    else
      case keycode
        IR#btnPower :     ' powerBtn
          term.cls
          term.str(@RB)
          reboot
        IR#btnPlay:
          if COG_RUN == 0
            cognew(LoadBuffer(@COG_RUN,@dSize),@vcStack)
        IR#spep :
          cognew(Clearbuffer(@COG_RUN),@vcStack)
        OTHER:
          term.locate(75,55)
          term.hex(keycode,4)
      
    waitcnt(clkfreq/10  + cnt)

PUB PopBuffer | t,q,size

  'size :=4
  
  t:= CMD_Q.Pop
  result:=t
  if not t==$FFFFFFFF
    CMD_P.Free(t)
      
PUB ClearBuffer(addCogRun) | t,q,size
  byte[addCogRun] ++
  'size :=4
  repeat
    t:= CMD_Q.Pop
    if not t==$FFFFFFFF
      CMD_P.Free(t)
      waitcnt(clkfreq/5 + cnt)
    else
      byte[addCogRun] --
      cogstop(cogid)
    
PUB LoadBuffer(addCogRun,addSize) | t,q,size
  byte[addCogRun] ++
  
  size:= byte[addSize]
  repeat
    
    if CMD_P.FindMaxFree > size
      t :=  CMD_P.Alloc(size)
      if not t == $FFFFFFFF
        q := CMD_Q.Push(t)
        if q == 0
          byte[addCogRun] --
          cogstop(cogid)
      else
        byte[addCogRun] --
        cogstop(cogid)
        
    else
      byte[addCogRun] --
      cogstop(cogid)
    waitcnt(clkfreq/5 + cnt)

DAT
        COG_RUN byte 0
        RB byte "Rebooting...",term#CLEAR_SCREEN
        IR_START byte "Starting IR port...",term#CLEAR_SCREEN
        INIT_MM byte "Init Mem. Manager.",term#CLEAR_SCREEN
        DMTEST byte "Dynamic Memory Test",term#CLEAR_SCREEN
        QNT byte "QCnt :",term#CLEAR_SCREEN